/* Some misc util functions for audio DSP work, written by Steve Harris,
   December 2000

   steve@plugin.org.uk
*/

// Limit a value to be l<=v<=u
#define LIMIT(v,l,u) ((v)<(l)?(l):((v)>(u)?(u):(v)))

// Truncate-to-zero modulo (ANSI C doesn't specify) will only work
// if v > -m and v < 2m
#define MOD(v,m) (v<0?v+m:(v>=m?v-m:v))

// Convert a value in dB's to a coefficent
#define DB_CO(g) ((g) > -70.0f ? pow(10.0f, (g) * 0.05f) : 0.0f)

// Linearly interpolate
#define LIN_INTERP(f,a,b) (((1.0f-f)*a) + f*(b))

// Truncate float to int
inline int f_trunc(float f) {
        f -= 0.5f;
        f += (3<<22);
        return *((int*)&f) - 0x4b400000;
}

// Round float to int (faster than f_trunc)
inline int f_round(float f) {
        f += (3<<22);
        return *((int*)&f) - 0x4b400000;
}
